---
title: RTCIceCandidate.RTCIceCandidate()
slug: Web/API/RTCIceCandidate/RTCIceCandidate
tags:
  - API
  - Audio
  - Candidate
  - Constructor
  - ICE
  - Media
  - RTCIceCandidate
  - Video
  - WebRTC
  - WebRTC API
  - rtc
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">The <code><strong>RTCIceCandidate</strong></code><strong><code>()</code></strong> constructor creates and returns a new {{domxref("RTCIceCandidate")}} object, which can be configured to represent a single {{Glossary("ICE")}} candidate.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>candidate</em> = new RTCIceCandidate([<em>candidateInfo</em>]);</pre>

<h3 class="syntaxbox" id="Parameters">Parameters</h3>

<dl>
 <dt><code>candidateInfo</code> {{optional_inline}}</dt>
 <dd>An optional {{domxref("RTCIceCandidateInit")}} object providing information about the candidate; if this is provided, the candidate is initialized configured to represent the described candidate.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A newly-created {{domxref("RTCIceCandidate")}} object, optionally configured based on the specified object based on the {{domxref("RTCIceCandidateInit")}} dictionary.</p>

<p>If <code>candidateInfo</code> is provided, the new <code>RTCIceCandidate</code> is initialized as follows:</p>

<ul>
 <li>Each member of the <code>RTCIceCandidateInit</code> object is initialized to the value of the property by the same name from {{domxref("RTCIceCandidateInit")}}. This includes the {{domxref("RTCIceCandidate.candidate", "candidate")}}, {{domxref("RTCIceCandidate.sdpMid", "sdpMid")}}, {{domxref("RTCIceCandidate.sdpMLineIndex", "sdpMLineIndex")}}, and {{domxref("RTCIceCandidate.usernameFragment", "usernameFragment")}} properties.</li>
 <li>The <code>candidate</code> string (which is SDP text) is parsed; each property found is stored in the corresponding field in the <code>RTCIceCandidate</code>. If any of the fields is invalid, parsing of the string silently aborts without throwing an exception. The default value of <code>candidate</code> is the empty string, which indicates that the candidate is an "end-of-candidates" message.</li>
 <li>The following fields are initialized to <code>null</code> if they are not included in the {{domxref("RTCIceCandidate.candidate")}} property: {{domxref("RTCIceCandidate.foundation", "foundation")}}, {{domxref("RTCIceCandidate.component", "component")}}, {{domxref("RTCIceCandidate.priority", "priority")}} , {{domxref("RTCIceCandidate.ip", "ip")}}, {{domxref("RTCIceCandidate.protocol", "protocol")}}, {{domxref("RTCIceCandidate.port", "port")}}, {{domxref("RTCIceCandidate.type", "type")}}, {{domxref("RTCIceCandidate.tcpType", "tcpType")}}, {{domxref("RTCIceCandidate.relatedAddress", "relatedAddress")}}, and {{domxref("RTCIceCandidate.relatedPort", "relatedPort")}}.</li>
</ul>

<div class="note">
<p><strong>Note:</strong> Parsing of the <code>candidate</code> string is performed using the <a href="https://w3c.github.io/webrtc-pc/#candidate-attribute-grammar">candidate-attribute grammar</a> from the WebRTC Specification.</p>
</div>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>TypeError</code></dt>
 <dd>The specified <code>RTCIceCandidateInit</code> has values of <code>null</code> in both the {{domxref("RTCIceCandidateInit.sdpMid", "sdpMid")}} and {{domxref("RTCIceCandidateInit.sdpMLineIndex", "sdpMLineIndex")}} properties.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>This constructor does not do complete validation of the specified <code>candidateInfo</code> object or string.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebRTC 1.0', '#dfn-rtcicecandidate', 'RTCIceCandidate()')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCIceCandidate.RTCIceCandidate")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{SectionOnPage("/en-US/docs/Web/API/WebRTC_API/Protocols", "ICE")}}</li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Connectivity">WebRTC connectivity</a></li>
 <li><a href="/docs/Web/API/WebRTC_API/Session_lifetime">Lifetime of a WebRTC session</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Signaling_and_video_calling">Signaling and video calling</a></li>
</ul>
